#include <rabbit.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include "fpoint.h"

#define PASSES 100

FPOINT fp1[100],fp2[100];
float fnum1[100],fnum2[100];
int fix1[100],fix2[100];

FPOINT fp_rand(void)
{
	fp_val rnum;
	rnum.f.fract=rand()+rand();
	rnum.f.integer=rand()+rand();
	return rnum.fpoint;
}


// fp2=fp1*fp2;
unsigned long test_dummy(FPOINT * pfp1,FPOINT * pfp2,unsigned len)
{
	unsigned long stime;

	int count=len,passes=PASSES;
	FPOINT x;
	FPOINT * opfp1=pfp1,* opfp2=pfp2;
	count=len;
	stime=getMilliSeconds();
	while (passes--)
	{
		while (count--)
		{
			x=*pfp1++;
			x=*pfp2++;
		}
		pfp1=opfp1;
		pfp2=opfp2;
		count=len;
	}
	x=x;
	return getMilliSeconds()-stime;
}

// this is fixed * a const
near long int fix_mul(int * f1,int * f2)
{
	long int fx=*f1;
	fx*=*f2;
//	fx/=1000l;
	return fx;
}

// fp2=fp1*fp2;
unsigned long test_fix(int * pfp1,int * pfp2,unsigned len)
{
	unsigned long stime;

	int count=len,passes=PASSES;
	int * pfp=pfp1;
	int * opfp1=pfp1,* opfp2=pfp2;
	while (count--)
		*pfp++=rand();

	count=len;
	pfp=pfp2;
	while (count--)
		*pfp++=rand();
	count=len;
	stime=getMilliSeconds();
	while (passes--)
	{
		while (count--)
		{
			*pfp2++=(int)(*pfp1++ * *pfp2);
//			pfp2++;
		}
		pfp1=opfp1;
		pfp2=opfp2;
		count=len;
	}
	return getMilliSeconds()-stime;
}


// fp2=fp1*fp2;
unsigned long test_fp(FPOINT * pfp1,FPOINT * pfp2,unsigned len)
{
	unsigned long stime;

	int count=len,passes=PASSES;
	FPOINT * pfp=pfp1;
	FPOINT * opfp1=pfp1,* opfp2=pfp2;
	while (count--)
		*pfp++=fp_rand();

	count=len;
	pfp=pfp2;
	while (count--)
		*pfp++=fp_rand();
	count=len;
	stime=getMilliSeconds();
	while (passes--)
	{
		while (count--)
		{
			*pfp2=fp_mul(*pfp1++,*pfp2);
			pfp2++;
		}
		pfp1=opfp1;
		pfp2=opfp2;
		count=len;
	}
	return getMilliSeconds()-stime;
}

float f_rand(void)
{
	// make these in the same range as fp
	float rnum;
	rnum=(float)rand();
	rnum+=(float)rand();
	rnum+=(float)rand()/32768.0;
	return rnum;
}

near float f_mult(float * f1,float * f2)
{
	return *f1 * *f2;
}

// fp2=fp1*fp2;
unsigned long test_f(float * pfp1,float * pfp2,unsigned len)
{
	unsigned long stime;
	int count=len,passes=PASSES;
	float * pfp=pfp1;
	float * opfp1=pfp1,*opfp2=pfp2;
	while (count--)
		*pfp++=f_rand();

	count=len;
	pfp=pfp2;
	while (count--)
		*pfp++=fp_rand();
	count=len;
	stime=getMilliSeconds();
	while (passes--)
	{
		while (count--)
			*pfp2++=*pfp1++ * *pfp2;
		pfp1=opfp1;
		pfp2=opfp2;
		count=len;
	}
	return getMilliSeconds()-stime;
}

void test_mul(FPOINT n1,FPOINT n2)
{
	char fp_text[16];
	FPOINT n3=fp_mul(n1,n2);
	fp_toa(n1,fp_text,5);
	printf("n1=%s\t",fp_text);
	fp_toa(n2,fp_text,5);
	printf("n2=%s\t",fp_text);
	fp_toa(n3,fp_text,5);
	printf("n1*n2=%s\t",fp_text);
	n3=fp_div(n1,n2);
	fp_toa(n3,fp_text,5);
	printf("n1/n2=%s\n",fp_text);
}

void main(void)
{
	FPOINT n1,n2,n3;
	int i,j;
	char fp_text[16];
	unsigned long ttime,overhead;
	WDT_DISABLE();
	startTimer(8,NULL,1);
	ipset0();
	j=-1;
	i=-1;
    j=i*j;
	printf("\nTesting overhead of loop for %d passes",PASSES);
	overhead=test_dummy(fp1,fp2,100);
	printf(".%ld us\n",overhead);
	printf("\nTesting multiply time for floats..");
	ttime=test_f(fnum1,fnum2,100);
	printf(".%ld ms\n",ttime-overhead);
	printf("Testing multiply time for FPOINT..");
	ttime=test_fp(fp1,fp2,100);
	printf(".%ld us\n",ttime-overhead);

	printf("Testing multiply time for fixed ii.fff (overhead included)..");
	ttime=test_fix(fix1,fix2,100);
	printf(".%ld us\n",ttime);

	printf("Value tests:\n");
	test_mul(FP_CONST(10.12345),FP_CONST(5.0));
	test_mul(FP_CONSTN(-1234.56789),FP_CONST(5.0));
	test_mul(FP_CONSTN(-10.10),FP_CONSTN(-5.0));

	for (i=0;i<5;i++)
	{
		n1=fp_rand()/256;
		n2=fp_rand()/256;
		test_mul(n1,n2);
	}
	n3=fp_atofp("12345.678911111");
	for (i=0;i<6;i++)
	{
		fp_toa(n3,fp_text,i);
		printf("fp_atofp(\"12345.678911111\") = %s, digits=%d\n",fp_text,i);
	}
	while (1)
	{
		n1++;
	}
}
