// multiply x * y/2, then shift left by 1,
#define umul2(x,y) _asm(_BC=(unsigned)x,_DE=(unsigned)y," xor a"," rr de"," mul","ld e,c"," ld d,b"," ld B,h","ld c,l",\
	" xor a"," rl e"," rl d"," rl c"," rl b",_BCDE)

// multiply x/2 * y/2, then shift left by 2,
#define umul4(x,y) _asm(_BC=(unsigned)x,_DE=(unsigned)y," xor a"," rr de",\
	" xor a"," rr b"," rr c",\
	" mul","ld e,c"," ld d,b"," ld B,h","ld c,l",\
	" xor a"," rl e"," rl d"," rl c"," rl b"\
	" xor a"," rl e"," rl d"," rl c"," rl b",_BCDE)

/*
   Copyright stuff

   Use of this program, for any purpose, is granted the author,
   Ian Kaplan, as long as this copyright notice is included in
   the source code or any source code derived from this program.
   The user assumes all responsibility for using this code.

   Ian Kaplan, October 1996

*/


FPOINTU _fp_divu(FPOINTU dividend,
		     FPOINTU divisor,
		     FPOINTU * rem_val )
{
	unsigned long int quotient;
	unsigned long int remainder;
  char num_bits;
  unsigned long d;
  char i;

  quotient = 0;
  remainder = 0;

  if (divisor == 0)
  {
  	*rem_val=remainder;
    return 0;
  }

  if (divisor > dividend)
  {
    *rem_val = dividend;
    return quotient;
  }

  if (divisor == dividend)
  {
    *rem_val=0;
    return 1l;
  }

  num_bits = 32;

  while (remainder < divisor) {
//    bit = (dividend & 0x80000000) >> 31;
    shiftl(remainder); // (remainder << 1) | bit;
	if (is_neg(dividend))
		or_one(remainder); //|=1;
    d = dividend;
    shiftl(dividend);
    num_bits--;
  }


  /* The loop, above, always goes one iteration too far.
     To avoid inserting an "if" statement inside the loop
     the last iteration is simply reversed. */

  dividend = d;
  remainder >>=1;
  num_bits++;

 for (i = 0; i < num_bits; i++) {
//    bit = (dividend & 0x80000000) >> 31;
    shiftl(remainder); // <<=1; //= (remainder << 1) | bit;
	if (is_neg(dividend))
		or_one(remainder); //|=1;
//    t = remainder - divisor;
//    q = !((t & 0x80000000) >> 31);
    shiftl(dividend);// = dividend << 1;
    shiftl(quotient); // <<=1; //= (quotient << 1) | q;
//    if (q)
	if (!((remainder - divisor) & 0x80000000l))
	 {
       remainder = remainder - divisor; //t;
     	or_one(quotient); //|=1;
     }
  }
  *rem_val=remainder;
	return quotient;

}  /* unsigned_divide */


